Welcome

Welcome to PixeLINK Help v9.1

Making Digital Imaging Simple

Thank you for choosing the PixeLINK family of cameras! At PixeLINK, we take great pride in the products and services we offer. To really take advantage of our products, please take a moment to quickly review the functionality of our cameras and software through this help file.

  • See what's new in this release of PixeLINK Help

  • To operate the camera immediately, follow our basic steps

  • Looking at little things? Check out our microscopy software, PixeLINK Capture SE.

  • Want to know about your camera's hardware and features and how to control them? See the Cameras Section.

  • Check out our technical support area if you're having a problem.

  • If you learn through Q&As, then go to our FAQs.

  • Don't like what you see, then send us feedback on how to improve this help file.

http://www.pixelink.com

© PixeLINK. All rights reserved.


What's New In This Release

Revision

Date

Notes

9.1

June 2014

  • All drivers are now been qualified and signed by Microsoft.

  • Added support for controlling a camera with programmatic focus control. Specially, added the following features

    • FEATURE_SHARPNESSS_SCORE

    • FEATURE_FOCUS

  • DirectShow is now supported on PL-D (USB3) cameras.

  • Added a NDIS6 driver for GigE Vision cameras.

  • USB3 cameras now function fully when connected to a USB2 port (at a reduced throughput).

9.0

Nov 2013

Updates to support new USB3 cameras

  • Bandwidth Limit

  • Actual Frame Rate

  • Updates frame descriptors

Various bug fixes

New features and fixes for Capture OEM

8.7

Mar 2013

Various bug fixes, and fixes for blue screens.

New features and fixes for Capture OEM.

Various bug fixes with PxLProcessorIdle tool.

Don’t bother looking for GEV cameras if the GEV driver is not loaded.

Resolved issue - Turning on a GPO in C-OEM, would sometimes return an ApiInvalidParameterError error.

PL-H cameras will now do a one-time auto tap-balance with each gain adjustment.

8.6

Aug 2012

Various bug fixes, and fixes for blue screens.

Several bug fixes related to FireWire stacks (new and legacy) on Windows 7.

It was possible for the API to return a very old frame.

Executables and runtime environment moved to Visual Studio 2008 SP1.

8.4

Mar 2012

Added support for development of 64-bit applications.

Several bug fixes for GigE cameras.

Several bug fixes associated with using callbacks.

8.2

Jan 2012

Various bug fixes.

8.1

Dec 2011

Various bug fixes, and fixes for blue screens.

Capture OEM now defaults to Advanced Mode.

Internal changes to mechanism for supporting GigE cameras.

Fixed a bug in the preview capability that would cause it to freeze.

Fixed a bug where a triggered frame could be lost if previewing.

Support for PL-E and PL-H GigE cameras.

NOTE: As of this release, GigE cameras do not support the following features:

  • FEATURE_EXTENDED_SHUTTER (aka Knee Points)

  • FEATURE_LOOKUP_TABLE

  • FEATURE_IMAGER_CLOCK_DIVISOR

This will be addressed in future releases. Please contact PixeLINK support for more information.

7.26

Jan 2011

Various bug fixes, and fixes for blue screens.

Support for PL-C FireWire B cameras.

7.25

Jul 2010

Updated signature files for silent installs.

7.24

Apr 2010

Fixed several blue screen issues associated with USB-over-Ethernet devices.

7.23

Feb 2010

Fixes to 1394 driver to accommodate 64-bit Windows platforms with 4GB or more of memory.

Enhanced DirectShow support.

Inclusion of the Version 3 Pleora software for GigE.

Added support for Lantronix UBox 2100.

Fixes to USB: Aborted applications could cause the camera to be uninitializable.

7.14

Mar 2009

Various bug fixes to DirectShow for USB and FireWire.

Various bug fixes to the API.

Capture OEM no longer re-queries for cameras when changing from one tab to another.

7.12

Dec 2008

64-bit FireWire and USB drivers for Vista 64 and XP-64.

Fixed "blue screen" error when DirectShow interacting with USB cameras.

Install errors on Vista 32, Vista 64 and Win2K have been resolved.

Increased 1394 frame readout time for triggered (with callback) frames.

Temporal noise filter and motion detector callbacks in Capture OEM.

Added /jumbo command-line parameter to instruct Capture OEM to use jumbo frames for GigE imaging.

Installs without GigE were not setting environment variables properly.

7.11

Aug 2008

Fixed several "blue screen" errors, that could occur on systems running with several USB cameras.

FFCTool can now support non-full-frame regions of interest (ROIs).

Improvements made to GigE cameras, addressing communication issues that could occur under heavy load. To get the full effect of these improvements, use Pleora's eBus Optimal driver, and IP Engine firmware 2.1.5 or later.

USB cameras no longer left in a streaming state if the controlling application shuts down without properly stopping streaming.

Added German language support to Capture SE.

7.03

May 2008

Added a "launch pad" for the API to documentation.

Updated the camera lists and features with new information.

Added a sharpening filter feature to some cameras.

Added information related to GigE tools.

7.01

Feb 2008

Updated the help files with GigE installation instructions, and Pleora help documentation.

6.21

Nov 2007

Added information about GigE cameras.

Updated CE statement.

Minor revisions to API and other documentation.

Updated information about Direct Show with USB cameras.

6.19

Sep 2007

Minor revisions to API.

Added image quality graphs.

Support in FFCWizard for CCD cameras.

6.18

Jul 2007

Added support for 12-bit cameras.

6.17

Jun 2007

New LabVIEW interface module and help files

Various bug fixes.

6.14

May 2007

Support for silent installs (signed drivers)

Added documentation for PL-B series of cameras.

6.7

Feb 2007

Various changes to better support USB cameras.

6.0

Aug 2006

Changes to improve performance on laptops.

Changes to the install procedure.

1.3

May 2005

Release 4 of PixeLINK API, driver and other software.

Minor release camera firmware updates.

Added documentation for PL-A770 series.

1.2

Mar 2005

Added some general updates to PixeLINK Capture OEM, the LabVIEW VIs, and a few other miscellaneous changes.

1.1

Jan 2005

Release 3 of the PixeLINK API (Version 4.1.18) and PixeLINK Capture OEM (Version 1.3.5)

1.0

Dec 2004

Release 2 of the PixeLINK API (Version 4.1.17) and PixeLINK Capture OEM (Version 1.3.1)

  • Release 4.1 of the PixeLINK API

  • LabVIEW VIs

  • New tutorial on how to control IIDC-compliant cameras

  • Upgraded PixeLINK Capture OEM

  • New Tools:

  • A Trigger Debounce tool allows the delay used to debounce the trigger input to be adjusted to accommodate analog or TTL input signals.

  • A Flat Field calibration tool can be used to field program the flat field calibration based on the application specific lighting and optics.


Capture OEM Introduction

PixeLINK Capture OEM

Welcome to PixeLINK Capture OEM, a real-time, interactive and easy-to-use application to:

  • operate PixeLINK cameras within 5 minutes of installation

  • verify the performance of PixeLINK cameras to one another or to a set standard

  • demonstrate the many features associated with PixeLINK cameras

  • see how this application relates to the function calls to the Application Programming Interface (API).

Topics Covered

To really take advantage of our PixeLINK Capture OEM, please take a moment to quickly review the functionality of this application through this help file.

  • Find out what's new in this release

  • Check out what you can do with this application

  • To operate your camera immediately, follow our quick start section.

  • Learn the basic steps of simple mode to set up and acquire an image

  • Need to go one step deeper, our advanced mode of operation allows for enhance image adjustment and manipulation

  • Go to quick tips section to get the best image quality.

  • The troubleshooting section helps you work you way through the problem.

Note

Regrettably, this application is designed to control PixeLINK cameras only.

Source Code

PixeLINK Capture OEM was created using the PixeLINK Camera API. Sample code from PixeLINK Capture OEM is available to assist developers in creating custom applications. The source code for PixeLINK Capture OEM s provided in Visual C++, bundled in a Microsoft Visual C++ project on the PixeLINK SDK CD-R. Please contact your local PixeLINK product vendor for more information on pricing and availability.

Compatibility

PixeLINK Capture OEM is compatible with other Version 4.0 PixeLINK camera products. PL-A660 series cameras are not supported.


What's New with PixeLINK Capture OEM

Revision

Release Date

Notes

2.3.7.9

June 2014

  • Several changes to support cameras equipped with API controllable focus. This includes adding a new ‘Lens’ tab as the primary interface to controlling the lens.

  • Added warnings when a USB3 camera is connected to a USB2 port.

  • Various bug fixes.

2.3.7.3

Nov 2013

  • Added support for USB3 cameras

  • New "Link Management" tab

  • Moved Packet Size to link management tab

  • Added Bandwidth Limit for USB3 cameras

  • Various bug fixes

2.3.3.0

Mar 2013

  • Fixed various bugs with knee points

  • Add new callback functions

    • Negative

    • Grayscale

    • Temporal noise filter

    • motion detector

  • Capture OEM now defaults to Advanced Mode.

  • Capture OEM defaults to "Auto" packet size for GigE cameras

1.4.6.

August 29, 2006

  • Added Slow Imager Mode

1.4.2

May 2005

  • Hard-coded correct gain steps for PL-A742. PL-A742 now has 9 gains steps instead of 10.

1.3.5

March 23, 2005

  • No longer stop stream to save settings.

  • Hard-code correct gains for PL-A622/774 and 623/776 cameras.

  • Fix Histogram Equalization on RGB to equalize YUV Y component.

  • Added /preview command line option to auto-start preview.

  • Added 6500 white balance value for 686/782 with hardware versions >= 2/130.

  • Added a help file (Help -> Contents or F1).

1.3.2

January 25, 2005

  • Changed the number of gain settings for the PL-A742.

  • Fixed the WhiteBalance settings for PL-A742/774/776 cameras.

  • Fixed Bayer to RGB conversion for GBRG format in the histogram.

  • A number of smaller bug fixes and features were also included.

1.3.1

December 1, 2004

PixeLINK Capture OEM has been extensively updated to improve ease of use.

The simple mode GUI screen includes most controls that are required to operate and demonstrate PixeLINK cameras. From the simple mode, the camera settings for exposure, gain, white balance, color temperature, saturation and gamma can be controlled. The ROI size can be selected and a pop-up dialog will allow more sophisticated selection of ROI size, pixel addressing modes and values. Image capture can be controlled with options to capture the full ROI at the maximum resolution and display the captured image while auto numbering the image name.

Specifically, controls have been added for:

  • white balance (color temperature);

  • white shading (RGB gains used to create an effective white balance);

  • new pixel addressing modes (binning, averaging, decimation, resampling);

  • flip, mirror and rotate modes;

The histogram window has been updated to display color and/or intensity information.

Frame rate controls have been added to limit the bandwidth on lap tops and bus constrained computers. Under the Camera menu item is a selection “Laptop Friendly Mode” which provides a list of ratios. Selecting one of these will limits the cameras bandwidth accordingly.

The advanced mode includes the simple mode GUI and uses tabs to provide additional and expanded features.

The DCAM tab has been removed. Its features were moved to the simple GUI and to the LUT and FFC tab.

The image enhancement tab has been changed to the LUT and FFC tab.

The Time lapse feature has been enabled and multiple frames can be averaged prior to capture.

A number of smaller bug fixes and features were also included.


Capture OEM Features

Features

W hat You See Is What You Get

PixeLINK Capture OEM streams real-time, high-quality video that can be viewed in a preview window on the computer monitor. Image size, color and exposure can be adjusted interactively through an easy-to-use control interface prior to image or video clip capture.

For the advanced user, PixeLINK Capture OEM also offers options of more complex image enhancements for exposure control, filtering, frame-by-frame property changes, all viewable in the preview window prior to capture. When PixeLINK Capture OEM is used in Advanced Mode, it displays a running log of API calls as they are executed by the application, allowing developers to see how to integrate features into their applications.


Quick Start

  1. Be sure to install the system correctly.

  2. Connect your camera.

  3. Go to the Windows Start menu and select Programs à PixeLINK à PixeLINK Capture OEM. When you start the application for the first time, it'll start up in simple mode and display the following control dialog. Your camera will appear in the Camera Select control. If not, please wait about 20 seconds while the software locates the camera and driver.

  4. Click on the Play button to start streaming video. A preview window will appear, something like this

  5. Adjust the controls to get a good image.

  6. You're now off and running. To get optimum image quality, check out our quick tips section or go to simple mode to get a description of each control.

  7. ENJOY!


Simple Mode

From the Menu Bar:

  • Click on "View", be sure to deselect "Advanced Mode" from drop down box.

If you close the application at this point, it will reappear in the same fashion.

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

PixeLINK Help - PixeLINK Capture OEM Help - Basic Mode

Simple Mode

The Simple Mode controls the image in real-time as seen by the preview window and is generally used to quickly evaluate the camera.

How to get Simple Mode

How do I know what feature is available for my camera? Click here to find out.

Once you've finished with this section, go to advanced mode to access the features that out of this world!

How to Manipulate the Controls

Click on the image below to go directly to the control that you want to modify.

Camera Select

The camera select drop down allows you to select the camera you are controlling. Once you've selected a camera, the controls will reflect the current setting for the selected camera. This might take a few seconds.

If no camera is connected, you'll see the following:

Video Preview

The video preview buttons allow you to start, stop and pause the incoming video stream, similar to what you would see on a VCR.

Exposure

Click on "Exposure Time" slider and drag to the desired exposure time setting, or enter the setting in the box provided. To have the camera determine the exposure time, click the Auto button and it will calculate a reasonable exposure time based on the average intensity of the image. To have the camera perform an auto-exposure all the time, tick off the check box.

Gain

Click on "Gain" slider and drag to the desired gain setting, or enter the setting in the box provided, or Click on "Auto" to allow the camera to search for the best gain setting.

Note

The gain has the effect of increasing both the video signal including the noise. Be careful when using this command. It is always preferable to increase the amount of light entering the camera. Use gain only for light starved applications.

Saturation

Color Cameras Only

Click on "Saturation" slider and drag to the desired saturation setting, or enter the setting in the box provided. A saturation value of 0 places converts the image in monochrome. Increasing the slider increase the vibrance of the image.

Brightness

Click on "Brightness" slider and drag to the desired setting, or enter the setting in the box provided. The Brightness control adds an offset to each individual pixel.

Gamma

The Gamma setting controls the contrast in the image by translating pixel values according to a logarithmic curve. A value of one is a linear translation. Higher or lower values of Gamma will result in missing codes in the image histogram. Check the "Gamma" [On] box if required, click on the slider and drag to the desired setting, or enter the setting in the box provided

Note

The Gamma curve is applied internally in the camera in the form of a calculated look-up table, the same table used by the "Look-up Table" feature. When the Gamma feature is activated the "Look-up Table" feature is disabled and vice-versa.

Frame Rate

The "Frame Rate" setting, in frames per second (fps), allows the user to adjust the frame rate per second of the image. When the camera is connected the frame rate range will be displayed.

Check "Frame Rate (fps)" [On] box if required, click on the slider and drag to the desired frame rate, or enter the setting in the box provided.

Color Temperature

Color Cameras Only

The "Colour Temp." {K} allows the user to select the required temperature setting in correlation to the light source being used. It is recommended that if the user wishes to use this setting that it be set before the white balance is performed.

Check "Color Temp." (K) [On] box if required, click on the slider and drag to the desired color temperature, or enter the setting in the box provided.

White Balance

Color Cameras Only

The "White Balance" setting allows the user to control the individual red, green and blue channel gains, so that non standard colour balance can be achieved. The "Auto" feature will attempt to white balance the gains (match the histogram peaks of each colour channel) based on the image data in the current ROI.

Direct the camera so that the object you wish to be "considered" as white is in the field of view, click on "Auto" under White Balance (this action will take a few seconds to complete)

Size

The "Size" setting allows the user to select the ROI. The user can use the drop down list to choose pre-selcted sizes or click on the box to type in custom settings.

Click on the "Size" drop down box and select predetermined required region of interest or click on the box and enter size and location selection

Image Capture

Click on "File Name" "Browse" drop down box and select the site to which the image will be saved

Click on "File Format" drop down box and select the format the image will be saved as (if AVI is selected enter the number of frames in the "No of Frames" box

Click on box provided to select "Capture Full Frame", "Capture Full Resolution", "Increment File Name After Capture", or "Preview Image After Capture" as desired/required

Click on "Capture" to take an image!


Quick Tips for Best Image Quality

To properly configure PixeLINK cameras for optimum image quality:

  1. Plug in the camera and open the software;

  2. Start the preview window.

  3. Configure the Region of Interest as required to get the proper field of view.

  4. Set the lens, lighting, exposure, brightness (only available in monochrome cameras) and gain so that the blacks are black and no areas in the image are saturated. Auto exposure will provide a good starting point. The histogram tool can be used when adjusting the above parameters to ensure that the image is not saturated. Ideally, you want all the image data to be within the histogram and to use most of the available gray scales. The figure below shows an example of a histogram that covers most of the gray scales available.

  5. For a color camera, adjust the White Balance feature to match the temperature of the light source. The default is incandescent 3200º Kelvin.

  6. Adjust the white point with the Auto White Shading or Auto White Balance feature. This feature uses the highest intensity areas of the scene to assess the white shading. Ensure that these areas are white or gray in color. Replace high-intensity colored objects with a gray or white card and ensure there is little or no saturation occurring in the image (i.e. gray is better than bright white).

  7. Adjust the Saturation to achieve the best color.

  8. Adjust the Gamma control as required to achieve the best image contrast.

Flat Field Correction

Any digital camera, has temporal and pattern noise. Fixed Pattern Noise (FPN), Photo Response Non Uniformity (PRNU), stuck pixels, are examples of pattern noise. Uncorrected, these noise sources can cause significant image artifacts.

PixeLINK camera corrects for these forms of pattern noise artifacts with a pixel-by-pixel flat field correction (FFC). Internal to the camera, a gain and offset is applied to each pixel so that the overall sensor has a uniform response. In addition, stuck pixels are corrected by replacing their value with the average of the neighboring pixels.

The FFC is factory calibrated at zero gain with a standard diffuse light source and no lens. While the calibration can be used at other camera settings, it is only valid for the gain and exposure setting used during the calibration. At other settings, image artifacts may be apparent.

For the best results, it is strongly recommended that users of PixeLINK cameras perform a FFC calibration with the lens and lighting that will be used in the field.

A software tool is available as part of the PixeLINK Camera Kit or SDK. Instructions on the process are included in the application dialog boxes.

Before evaluating the camera on image quality, users should determine the exposure and gain settings required based on the factory calibration for the lens and lighting used in their application. Then, with the subject removed and with a uniform surface under examination, perform the FFC calibration. Once this is complete, continue with the evaluation of the image quality.

If a single gain and exposure setting is not possible, there will be practical limits on the gain and exposure times that can be used before the noise artifacts cause unacceptable degradation to the image quality.

Thermal Considerations

Machine vision users should heat-sink cameras since temperature affects the black level offset. Waiting a few minutes for the camera to equilibrate in temperature will minimize temperature induced image quality drift. See Thermal Considerations.


Advanced Mode

You've come to the right spot if you really want to take a PixeLINK camera for a spin! Click on the links below to see how to operate these advanced features.

  • Image capture as JPEG, Adobe Photoshop, Bitmap and Tiff files

  • Video clip capture as Windows AVI files

  • Controls for image properties

  • User-specifiable Region of Interest (ROI)

  • Trigger and General Purpose Output (GPO) controls

  • API Call Log to aid in development and diagnostics

  • Advanced Software Features:

  • Extended Shutter for scenes with large dynamic range (Multiple slope exposure)

  • User-specifiable Lookup Tables (LUT)

  • Callback functions (filters, overlays)

  • Descriptors

Of course, when you're finished here you can always review the Menu Bar.


Basic Controls Tab

Basic Controls

The Basic Controls tab controls the image in real-time as seen by the preview window.

How to get to Basic Controls

From the Menu Bar:

  • Click on "View", select "Advanced Mode" from drop down box

  • Click on "Basic Controls" tab

If you close the application at this point, it will reappear on this tab.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

You'll notice that the basic controls tab is nearly identical to simple mode. The only exception are the tabs on top of the application to help navigate through the features and the API call log below. Click on the image below to go directly to the function that you want to modify.


LUT & FFC Tab

LUT & FFC

The LUT & FFC tab allows the user to access advanced functions. The Lookup table (LUT) control provides the user a simple way to manipulate the grey scale image data coming from the camera via a simple lookup table. The Flat Field Correction (FFC) control, activated by default when the camera is turned on, provides the user with the ability to correct for non uniformity within the sensor.

How to get to LUT & FFC

From the Menu Bar:

  • Click on "View", select "Advanced Mode" from drop down box

  • Click on "LUT & FFC" tab

If you close the application at this point, it will reappear on this tab.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

Click on the image below to go directly to the function that you want to modify.

Look Up Table

Click "Enable" in the box provided to activate the LUT.

By default, the transfer function is set as a straight bypass function, where out = in. To manipulate the transfer function, click on the small box at either end of the red line and drag it to the desired location. You can do repeat this operation as many set points as you wish to achieve the desired effect.

Click "Update Now" to load the lookup table parameters into the camera and to view the resulting image in the preview window. Click auto update to continuously update the LUT within the camera.

The table to the left of the transfer function shows the resulting input/output relationship where the data entering the LUT is on the left, and the data leaving the LUT is on the right.

You can reset the transfer function at any time by right clicking the curve and selecting "Reset".

To create a Curve on any segment, right click on the segment and select "Convert to Curve". Two crosses can be dragged on the graph to create the desired effect that you want.

Flat Field Correction

The Flat Field Correction control is turned on as a default. FFC corrects for any nonuniformity in the sensor and in the light. To deactivate the FFC, click on the box provided. "The FFC Calibrated at a gain of" refers to the gain level that the FFC was calibrated at. Most cameras are calibrated at 0db at the factory.

Temperature Sensor

  • The Temperature setting allows the user to monitor the temperature of the camera (in degrees Celsius). This is a read-only function.


Region of Interest Tab

Region of Interest

The Region of Interest tab controls the size of the image being captured and its location with respect to the entire image array.

How to get to Region of Interest

From the Menu Bar:

  • Click on "View", select "Advanced Mode" from drop down box

  • Click on "Region of Interest" tab

If you close the application at this point, it will reappear on this tab.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

Click on the image below to go directly to the function that you want to modify

.

ROI Size and Location

The Region of Interest (ROI) is the area of the sensor being viewed at any given time. The region of interest appears as a red frame superimposed in the "Region of Interest - Size and Location" window. Full view of the sensor is shown in white and is camera dependant.

  • Select the size as required. For preset sizes, click on the "Size" drop down menu and select. Enter values in the "Left", "Top", "Width" and "Height" boxes for custom sizes and location, or click and drag on red box and drag.

  • Click on "Pixel Addressing" and choose the type of addressing desired. Choose between decimation, resampling, binning or averaging. The addressing factor can then be selected and is camera dependant.

  • Click "Center" to reposition the ROI in the center of the imager area

Rotation

To rotate the image, click on desired setting in "Rotate" section. Most cameras do not support rotate in the camera. The host therefore performs the operation at the expense of greater CPU utilization.

Image Flip

To flip the image, click on desired setting in "Image Flip" section. Most cameras do not support flip in the camera. The host therefore performs the operation at the expense of greater CPU utilization.

Pixel Format

To select the appropriate pixel format, click on "Pixel Format" drop down menu and select desired setting. Pixel Formats are camera dependant, the most common being 8-bit monochrome for black and white cameras and 24-bit RGB for color cameras.

The following flags are used to specify the format of a pixel.

Value | Description
PIXEL_FORMAT_MONO8 | Grayscale, 8 bits per pixel
PIXEL_FORMAT_MONO16 | Grayscale, 16 bits per pixel, with the first byte is the most significant byte
PIXEL_FORMAT_YUV422 | Color, 16 bits per pixel, with a coding pattern of U0, Y0, V0, Y1, U2, Y2, V2, Y3, …
PIXEL_FORMAT_BAYER8_RGGB | 8 bits per pixel. Data in Bayer pattern format with first pixel begin red.
PIXEL_FORMAT_BAYER8_GRBG | 8 bits per pixel. Data in Bayer pattern format with first pixel begin green (on a red line).
PIXEL_FORMAT_BAYER8_GBRG | 8 bits per pixel. Data in Bayer pattern format with first pixel begin green (on a blue line).
PIXEL_FORMAT_BAYER8_BGGR | 8 bits per pixel. Data in Bayer pattern format with first pixel begin blue.
PIXEL_FORMAT_BAYER16_RGGB | 16 bits per pixel. Data in Bayer pattern format with first pixel begin red.
PIXEL_FORMAT_BAYER16_GRBG | 16 bits per pixel. Data in Bayer pattern format with first pixel begin green (on a red line).
PIXEL_FORMAT_BAYER16_GBRG | 16 bits per pixel. Data in Bayer pattern format with first pixel begin green (on a blue line).
PIXEL_FORMAT_BAYER16_BGGR | 16 bits per pixel. Data in Bayer pattern format with first pixel begin blue.
PIXEL_FORMAT_RGB24 | Color, 24 bits per pixel
PIXEL_FORMAT_RGB48 | Color, 48 bits per pixel

Pixel Addressing

The Pixel Addressing feature reduces the number of pixels that are read from the ROI.

Pixel Addressing is controlled by two parameters – a Pixel Addressing mode and a value.

The Pixel Addressing mode determines how the number of pixels is reduced. The mode of Pixel Addressing can be decimate (0), averaging (1), binning (2) or resampling (3), depending on what the camera supports.

The Pixel Addressing value can be considered as the size of a block of pixels that will be reduced to a 2x2 group. With a Pixel Addressing value of "None", the Pixel Addressing mode has no effect and all pixels in the ROI will be returned. For Pixel Addressing values greater than 1, the number of pixels will be reduced by the value. For example, a Pixel Addressing value of 6 x 6 will decrease the pixels to a 2 x 2 block – a reduction of 4/36 or 1/9.

The decimate mode will drop pixels all the pixels in the block except for the top-left group of four. At the highest Pixel Addressing value of 6, a 12 x 12 block of pixels is reduced to 2 x 2. At this level of reduction detail in the scene can be lost and color artifacts introduced.

The averaging mode will average pixels with the similar color within the block resulting in a 2x2 Bayer pattern. This allows details in the blocks to be detected and reduces the effects of color artifacts.

The binning mode will sum pixels with similar color within the block reducing the block to a 2x2 Bayer pattern. Unlike binning with CCD sensors, this summation occurs after the image is digitized so no increase in sensitivity will be noticed but a dark image will appear brighter.

If your camera supports asymmetric pixel addressing, then you can specify different factors to be applied to the horizontal and vertical dimensions. Note that the same pixel addressing mode is applied to both dimensions.

The resampling mode uses a different approach involving the conversion of the Bayer pattern in the blocks to RGB pixels. With a Pixel Addressing value of 1, resampling has no effect. With a Pixel Addressing mode of 2 or more, resampling skips a bayer to RGB conversion step and converts the block of 10-bit pixels to one 30-bit RGB pixel by averaging the red, green and blue channels. Setting the video format to YUV422 mode will result in the best image quality while resampling. Resampling will create images with the highest quality and the least artifacts.

Pixel Addressing will reduce the amount of data coming from the camera. However, only the Decimate mode will permit an increase in the frame rate. Averaging, binning and resampling modes will have the same frame rate as if the Pixel Addressing value was 1 (no decimation.)

Pixel Addressing works in the same fashion with color or monochrome sensors.

Note

If the ROI is changed while the preview window is open, the preview window may need to be reset manually (CTRL - R, or click on "View", left click on "Reset Preview Window").


Image Capture Tab

Image Capture

The "Image Capture" tab allows the user to capture images in different ways i.e., one at a time, automated using a "trigger", and elapsed time and in various file formats

How to get to Image Capture

From the Menu Bar:

  • Click on "View", select "Advanced Mode" from drop down box

  • Click on "Image Capture" tab

If you close the application at this point, it will reappear on this tab.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

Click on the image below to go directly to the function that you want to modify.

Image Capture

  • At any time you can click on "Capture" to capture an image

  • If you wish to change the file name or format:

  • Click "Browse" to specify a name, location and format for the image file.

  • You can also select one of the following formats for the "File Format" drop down menu

  • Bitmap

  • JPEG

  • PSD

  • Tiff

Increment File Name

Check the box Increment File Name After Capture to add a numeric suffix to the file name and automatically increment the suffix each time an image is captured. This option is selected automatically with "Time Lapse Capture"

Note

Note; Incrementing stops if switched to "Simple Mode"

Preview after Capture

Check the box Preview Image After Capture to automatically display the image immediately after capture. The image is displayed in the application currently associated with the selected file type.

Capture Full Frame

Check the box Capture Full Frame to capture a full field-of-view image, regardless of the ROI or the size of the preview window.

Capture Full Resolution

Check the box Capture Full Resolution to capture a full image with pixel addressing disabled.

Averaging Frames

Check the box Average Over to capture an number of frames as specified in the field and average them out, to reduce the noise level of an image.

Time Lapse

Check the Time Lapse Capture box to capture a series of images over a period of time. The fields below will be highlighted.

Click and enter number for Capture Every to capture an image every period specified For the duration/time you wish to capture images. You have the option to auto-expose your image prior to capture. This is useful when the light conditions are changing.


Video Capture Tab

Video Capture

The "Video Capture" tab allows the user to capture and display "Clips" or groups of frames (partial or full), save the raw data, and save the formatted clip to be previewed immediately or at a later date.

How to get to Video Capture

From the Menu Bar:

  • Click on "View", select "Advanced Mode" from drop down box

  • Click on "Video Capture" tab

If you close the application at this point, it will reappear on this tab.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

Click on the image below to go directly to the function that you want to modify.

Clip Capture

  • Click on the box provided in "Clip Capture" and enter the desired number of frames to be included in the clip.

  • Click in the box provided to "Capture Full Frame" or leave the box un-checked to capture a specified frame size (to choose frame size, left click on ROI tab and choose desired size).

  • Click in the box provided to "Save Raw Data File", left click on "Browse" to choose storage location, left click in the box provided to "Increment File Name After Capture"

  • Click in the box provided to "Save Formatted Clip", left click in the box provided to "Browse" to choose desired storage location, left click on the drop down menu arrow to choose file format (AVI is the only choice at this time), left click in the box provided to "Increment File Name After Capture", left click to "View Clip After Capture".

  • Click on Begin Capture to capture images!

PixeLINK Data Stream File Format

The PixeLINK Data Stream file (.pds) is a binary file with the following format:

U32 | "magic number" 0x04040404, indicating that this is a valid PDS file
U32 | number of frames in the file
FRAME_DESC | FRAME_DESC for the first frame. NOTE: The uSize field indicates the size of the FRAME_DESC used in the PDS.
data | Data for the first frame. NOTE: Format and size of data can be determined by examining the FRAME_DESC for this frame.
FRAME_DESC | FRAME_DESC for the second frame
data | Data for the second frame
... | And so on until...
FRAME_DESC | FRAME_DESC for the last frame.
data | Data for the last frame


Descriptors Tab

Descriptors

A descriptor is a collection of camera feature properties that is applied to an image frame. Since each frame can have a unique descriptor, they can be used to change camera settings on a frame by frame basis. The "Descriptors" tab allows the user to add/modify/delete descriptors and view the resulting frame capture.

How to get to Descriptors

From the Menu Bar:

  • Click on "View", select "Advanced Mode" from drop down box

  • Click on "Descriptors" tab

If you close the application at this point, it will reappear on this tab.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

Click on the image below to go directly to the function that you want to modify.

What it is

A descriptor is a set of parameters associated with a frame that allows for rapid changes of camera parameters in a deterministic manner

The descriptor defines the value of each parameter

Each frame can have a unique descriptor, custom descriptors can be used to change camera settings on a frame-by-frame basis for each frame in the video stream

The camera will apply each descriptor in turn when capturing images and will output one frame per descriptor

After the last descriptor is used, the next frame in the stream will return to the first descriptor

When to use

Descriptors are useful for obtaining different views of the same image.

  • Zooming in on several smaller regions of interest within a larger image

  • Panning to different ROI locations in the field of view

  • Obtaining images with different exposure times

  • Sequencing through various trigger inputs and General-Purpose outputs (GPOs) settings

How to use

Descriptors can be programmed using PixeLINK Capture OEM. Most features that can be controlled via Capture OEM can be modified in a descriptor. The exceptions are the gamma correction/look-up table feature and Flat Field Correction.

  • Select the Descriptors tab in the PxLDevApp

  • Select the Host Update mode

  • Click create to enable the first descriptor

In the Descriptor Focus

  • Select the button to the right of any of the camera control settings that are highlighted in bold

  • Modify the value in the dialog that pops up

  • Close the dialog

  • Note: Changing any of the camera settings on the normal tab panels will also change the setting for the current descriptor

Add / Remove Descriptors

Descriptor Creation

  • Click on “Create”

  • You will see a new descriptor labelled “Descriptor # 1” in the tree view

  • Repeat this step for as many descriptors as desired. (ApiInvalidParameterError will be returned if you attempt to create more descriptors than the camera supports).

Descriptor Setup

  • Click on the descriptor that you wish to modify in the tree view, labelled “Descriptor # N” (where N is the number of the descriptor you wish to modify)

  • Click on the feature controls from the feature list and set the desired settings for the descriptor.

  • Repeat these steps for all descriptors.

  • Click on “Play” to see a preview of the descriptors that have been created

Descriptor Removal

  • Click on the descriptor that you wish to remove in the tree view, labelled “Descriptor # N” (where N is the number of the descriptor you wish to remove)

  • Click on “Delete”, the selected descriptor will be removed.

  • Or, to remove all descriptors at once, click on “Delete All”

Update Mode

Change a Descriptor without affecting Camera

  • To change a descriptors settings without affecting the image being displayed, click on the desired descriptor and then click on "Host"

  • Click on the feature controls that you wish to modify

  • To apply the "Host" descriptor settings, click on "Update Now" or click on "Camera

Note

It is recommended that all changes to preset descriptors be made in "Host Mode" and updated accordingly.

Descriptor in Focus

This entry indicates which descriptor is currently in focus.

  • “none” means that no descriptors have been created

  • N/A next to a "Descriptor in Focus" means that it is not available with the camera configuration in use


External Control Tab

External Control

The External Control tab allows the user to control external devices connected to the camera, such as a triggers or strobes.

How to get to External Control

From the Menu Bar:

  • Click on "View", select "Advanced Mode" from drop down box

  • Click on "External Control" tab

If you close the application at this point, it will reappear on this tab.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

Click on the image below to go directly to the control that you want to modify.

Triggers

Trigger Switch

On / Off - used to activate and deactivate the trigger

Trigger Mode

Characterization of the trigger signal pulse from modes 0 through 14. Current modes include:

  • 0 - Trigger on pulse leading edge for shutter integration time

  • 1 - Pulse width defines start and end of integration

  • 2 - Start integration at first pulse leading edge and end at Nth pulse leading edge

  • 3 - Camera issues triggers internally at fastest frame rate for N frames

  • 14 - Camera will capture N frames after first trigger edge

Trigger Type

Represents the means of delivering the trigger signal to the camera.

  • free running (Frames are output continuously, driven by an internal trigger that occurs as frequently as possible)

  • software (the trigger occurs upon receiving a software command)

  • hardware (the trigger comes from an external device as an electrical pulse)

Trigger Polarity

Represents the polarity of the trigger signal (the rising or falling edge of the voltage signal). Select "Positive or "Negative"

Note

"Positive" has a different meaning for enclosed cameras, which has optocouplers and board-level cameras, which have TTL inputs. See Triggers and GPOs for a detailed description.

Trigger Delay

Represents the delay from trigger detection to start of integration.

Trigger Number

Represents a numeric parameter required by some trigger "Modes" and "Types". If this parameter is not required, the field is disabled and represented as N/A.

Trigger with controlled lighting

Trigger with Controlled Lighting allows control over the manner in which rolling shutter or fast-reset shutter cameras function when using a trigger. In normal operation, a rolling shutter camera is resetting, exposing and reading out information concurrently. This results in consistent exposure times and faster frame rates. However, since the rolling shutter is only exposing a portion of the sensor at a time, this mode is not effective at stop motion imaging.

To capture stop motion with a rolling shutter camera requires controlled lighting using a strobe, shutter or both. The sensor must be fully reset prior to the exposure beginning. Then, once the exposure is complete, the sensor starts readout. During the readout, the sensor remains sensitive to incident illumination - hence the need for controlled lighting.

There are applications where the camera does not need to stop motion. In these cases, Trigger with Controlled Lighting can be turned off (0) and the sensor will use a full rolling shutter to capture images. The rolling shutter will start when the trigger event occurs.

Cameras that support global shutter operation do not support this feature.

Trigger Description

Once the trigger mode is set, the description of the selected trigger appears in the Trigger Description box.

Update Trigger

When the parameters are set, click on "Update Trigger" to send these parameters to the camera.

GPOs

GPO Switch

On / Off - used to activate and deactivate the GPO pins

Number - the GPO pin used to carry the current signal

GPO Mode

Represents the type of signal being generating. Current modes include:

  • Strobe - Pulse fires for specified duration and delay after trigger input.

  • Normal - Pulse width, or steady state as set through API control.

  • Pulse - Specified number of pulses, polarity, and duration each time API requests it.

  • Busy - Pulse enabled when camera is integrating a frame.

GPO Polarity

Represents the polarity of the GPO signal (the rising or falling edge of the voltage signal). Select "Positive or "Negative"

Note

"Positive" has a different meaning for enclosed cameras, which has optocouplers and board-level cameras, which have TTL inputs. See Triggers and GPOs for a detailed description.

GPO Parms

Up to three additional parameter fields may appear dependant upon what "GPO Mode" is selected.

Update GPO

When the parameters are set, click on "Update GPO" to send these parameters to the camera.

GPO Description

Once the GPO mode is set, the description of the selected trigger appears in the Trigger Description box.


Callbacks Tab

Callbacks

A "Callback" function transforms the image's pixel data just prior to display or capture. Typically, this function is intended to process an incoming image, or to add a graphic "overlay" to the image. The Callbacks tab allow the user to select a pre-defined callback on real-time or captured images.

How to get to Callbacks

From the Menu Bar:

  • Click on "View", select "Advanced Mode" from drop down box

  • Click on "Callbacks" tab

If you close the application at this point, it will reappear on this tab.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

Click on the image below to go directly to the function that you want to modify.

PixeLINK Capture OEM includes five sample callback functions (four image filters and a histogram stretch) and the option of using a custom bitmap overlay graphic (see table below). Custom filters or other callback functions can be incorporated into or called by applications created using the PixeLINK Camera API.

Different callback functions may be applied to the preview window, captured images, and captured video clips.

Callback

Effect

Negative

A negative image is a total inversion of a positive image, in which light areas appear dark and vice versa. A negative color image is additionally color reversed, with red areas appearing cyan, greens appearing magenta and blues appearing yellow.

Grayscale

Grayscale images have many shades of gray in between. Grayscale images are also called monochromatic, denoting the presence of only one (mono) color (chrome).

Saturated and Black

Turns fully saturated pixels, into RED pixels and black pixels into BLUE. Makes it easy to identify ‘hot spots’ on an image.

Threshold (50%)

The filter does image binarization using specified threshold value. All pixels with intensities equal or higher than threshold value are converted to white pixels. All other pixels with intensities below threshold value are converted to black pixels.

Temporal Noise Filter

Attempts to filter out noisy pixels over time. That is, individual pixels that seem to fluctuate from one streamed image to the next, while it’s neighbors do not.

Motion Detector

Given a stream of images, pixel values that are consistent from one image to the next, are shown as black. Similarly, pixels that change from one image to the next, are shown as saturated.

ASCII

The pixel dN values, are mapped to the ASCII character set.

Median Filter (3 x 3)

Reduces random noise, particularly "shot noise" (extreme values of individual pixels), based on median brightness level of local pixel values.

Low Pass Filter (3 x 3)

Smoothes image and reduces random noise, based weighting of local pixel values.

High Pass Filter (3 x 3)

Sharpens image and reduces gradual variations based on weighting of local pixel values

Sobel Filter (3 x 3)

Detects edges based on gradients (differences) in local pixel values.

Histogram Equalization

Improves the contrast of "muddy" images by; detecting the minimum and maximum pixel values in the input range calculating a linear conversion that maps the minimum intensity value to full black and the maximum intensity value to full white creating an enhanced image by converting all of the pixels of the input image accordingly

This has the effect of stretching out the pixel values to the widest possible range, thereby increasing contrast and depth in the image.

Bitmap Overlay

Adds a bitmap, such as a company logo or a time stamp, on the image. Enter the name and location of the bitmap in the "File Name Box", or use the "Browse" button to locate the file.

Notes:

  • The bitmap must be a .bmp file in 24-bit RGB format

  • The overlay image is placed in the upper left corner of the frame

  • Any white areas (RGB 255, 255, 255) in the overlay image are treated as transparent i.e. the video will show through them.

  • An overlay image will not be resized if the size of the ROI is changed

Callbacks on the Preview Window

  • To apply a Callback function to the Preview Window, select desired callback, click on drop down menu and select the function you want.

  • To apply a bitmap overlay to the Preview Window, click on "Browse" and select desired bitmap from your files.

Callbacks on Image or Video Capture

  • Repeat for "Image Capture" and "Video Capture" functions if required

Sharpness

The Sharpness feature is a standard convolution filter applied to the intensity (luma) channel as

where [image] is the Laplacian of the pixel luma at location (i,j). The Laplacian is implemented as a 3x3 convolution kernel filter as follows.

In the equation, Ko is a scaling factor applied to the original pixel value which, in the sharpness filter, is set to one. Ks is a scaling factor applied to the result of the Laplacian. It is controllable as the only parameter (fValue) between zero and two. Setting the scaling factor to zero has no affect on the image. Setting it to two (200%) will increase the sharpness of the image to the maximum degree. To limit the noise, the result of the scaled Laplacian is only added if it is greater than a factory set limit of 75 digital numbers on 10-bit data.

For color cameras, the raw sensor data is converted to a YUV format and the sharpness filter is applied to the Y (intensity) channel only. The modified Y intensity data combined with the UV terms and further converted to the desired output Pixel Format. For best performance, select the YUV Pixel Format to reduce the amount of noise added to the image in the format conversions.

The sharpness filter will add noise to the image, and setting the scaling factor above 50% tends to accentuate the noise. Noise will also increase with an increase in gain. For color cameras, YUV is preferable to Bayer when using the sharpening filter. The magnitude of the scaling factor to use is subjective.


Extended Shutter Tab

Extended Shutter

The Extended Shutter Tab allows the user to set knee points to adjust the exposure of the image. Certain PixeLINK cameras support integration time on multiple slopes, providing a non-linear camera response to light, when the extended shutter function is enabled. Knee points are used to specify intervals at which pixel values are reset to defined output levels, from which integration continues.

How to get to Extended Shutter

From the Menu Bar:

  • Click on "View", select "Advanced Mode" from drop down box

  • Click on "Extended Shutter" tab

If you close the application at this point, it will reappear on this tab.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

Click on the image below to go directly to the function that you want to modify.

Procedure

  • Start PixeLINK Capture OEM and begin the video preview

  • Choose an ROI size

  • Select an exposure time that reveals detail in the darker regions of your preview, while overexposing bright areas

Exposure control for extended dynamic range

  • Set Exposure Time for darkest areas

  • Add knee points for length of time to expose pixels in brighter areas

  • Each subsequent knee point gets only a portion of the remaining grey scale range

Example 1

These three images were captured of the same target using exposure times of 20ms, 4ms, and 0.04ms. Observe the level of detail visible in the bright and dark areas within the scenes.

The image below was captured of the same target using the extended shutter with an overall exposure of 20 ms, knee point 1 set to 4ms, and knee point 2 set to 0.04 ms

Note: This corresponds to calling PxLSetFeature with values of 16 ms for knee point 1, and 19.96 ms for knee point 2.

Example 2

  • Overall exposure: 40ms

  • At 25ms of exposure, all pixels above 50% of VSat (127DN in 8-bit mode) are reset back to this level with 15ms of exposure time remaining

  • At 36.5ms of exposure, all pixels above 75% of VSat are reset back to this level with 3.5ms of exposure time remaining


Menu Bar

File Menu

Import Config File …

Load and apply camera features settings stored in a PixeLINK Camera Configuration (.pcc) file.

Export Config File …

Save the current camera settings to disk, in a PixeLINK Camera Configuration (.pcc) file. Note that descriptors and the lookup table are saved in the exported file. File paths (such as for image capture) are not saved.

Exit

Shut down PixeLINK Capture OEM.

View Menu

Advanced Mode

Switch to PixeLINK Capture OEM’s advanced mode, which gives you access to additional camera control functions. After the first session, PixeLINK Capture OEM starts with the last mode used.

Always On Top

Change the float setting of the application. When this is switched on, PixeLINK Capture OEM will always remain on top of other windows on the computer desktop; otherwise, other windows can overlap it.

Reset Preview Window (CTRL-R)

Reset the preview window dimensions to correspond to the current ROI and Pixel Addressing mode. If the current ROI is too large too fit on your desktop, the window size will be reduced.

The preview window can be resized manually by dragging its edges, or by clicking its Maximize icon. This will not affect the number of pixels (vertically or horizontally) in the image. Note that resizing the preview window may lower performance as Windows uses more processing power to stretch the image data to fit the display.

Auto Reset Preview Window

When this setting is turned on, the preview will automatically resize itself after any change to the ROI or Pixel Addressing mode.

Restore GUI Defaults

Restore PixeLINK Capture OEM to its default settings. See Application Defaults for more information.

Histogram (CTRL-H)

Open a window with a histogram displaying the distribution of pixel values in the output image. See sample image

Camera Menu

Load Camera Settings…

Load feature settings (factory defaults or custom) from the camera’s non-volatile memory.

Save Camera Settings…

Save the current feature settings to the camera’s non-volatile memory.

Set Camera Name

Give the active camera a name for easier reference. This name is stored in the camera’s non-volatile memory.

Laptop Friendly Mode

Puts the application in a state where the frame rate will be maintained at a fraction of the available maximum frame rate. This is useful on laptop computers or slower desktop computers that are not able to process frames at the full frame rate.

Help Menu

About PixeLINK Capture OEM…

Display information about the software and the camera, as shown below. For technical support or servicing queries, please have this information available if possible.

PixeLINK Software Info—Identifying information about the software

  • Application Version: The version of the PixeLINK Capture OEM

  • Driver Version: The version of the camera driver used with the application

  • API Version :The version of the application programming interface (API) used to create PixeLINK Capture OEM. The API is included in each PixeLINK SDK.

Active Camera—Identifying information about the camera currently in use

  • Serial Number

  • Vendor Name

  • Model Name

  • Camera Name

  • Firmware Version

  • FPGA Version


Application Defaults

The following PixeLINK Capture OEM features are reset when Restore GUI Defaults is selected:

Feature | Default Value
External Control
GPO Number | 1
Image Enhancement
Enable Lookup Table | selected
Show Histogram | selected
Auto Update | selected
Region of Interest
Apply To | Stream
Image Capture
Increment File Name After Capture | not selected
Preview Image After Capture | selected
Capture Full Frame | not selected
Time Lapse Capture | not selected
Capture Every | 10 seconds
For | 1 minute
Auto Expose Before Each Capture | not selected
Video Capture
Number of Frames | 10
Capture Full Frame | not selected
Save Raw Data File | not selected
Increment File Name After Capture (for raw data file) | not selected
Save Formatted Clip | selected
Increment File Name After Capture | not selected
View Clip After Capture | selected


Link Management

The Link Management tab allows the user to access advanced functions. The max packet size control allows an application to control the maximum packet size that the software can receive. The Bandwidth Limit control, will place an upper bound on the amount of aggregate bandwidth the camera may use for image data. Of course, each individual packet associated with image data must (by definition) be sent at the full link speed -- but over a longer period of time, the amount of overall bandwidth consumed by the camera, will not exceed this limit. This feature may be particularly useful, if you plan on using multiple cameras on a single bus, or connecting the camera onto a bus that has another high throughput device.

How to Manipulate the Controls

Click on the image below to go directly to the function that you want to modify

Max Packet Size

This feature allows an application to control the maximum packet size that the software can receive. When the camera supports this feature the default status is "Auto", this will query the setup to see what packet size is supported on the camera and NIC(network interface card). You can also uncheck "Auto" and select either 1500 or 9000 (Jumbo Frames).

Bandwidth Limit (Mbps)

When enabled, this feature will place an upper bound on the amount of aggregate bandwidth the camera may use for image data. Of course, each individual packet associated with image data must (by definition) be sent at the full link speed -- but over a longer period of time, the amount of overall bandwidth consumed by the camera, will not exceed this limit. This feature may be particularly useful, if you plan on using multiple cameras on a single bus, or connecting the camera onto a bus that has another high throughput device.


Lens Tab

Lens

The Lens tab allows the user to access advanced functions.

What's Available

It's pretty simple.

Features are camera dependent. A feature's availability will be determined only when the camera is connected to the computer at run-time.

For example, if the exposure function is available on the camera, you should see the exposure settings to look like this

In this case, the limits of the exposure time is 63 usec to 2 seconds, with the current setting set to 100 msec. If the function is unavailable, it will be greyed out as shown below

Note

All the controls will be greyed out if no camera is connected to the computer.

How to Manipulate the Controls

Click on the image below to go directly to the function that you want to modify.

Sharpness Score - Region of Interest

A set of control information the camera uses to calculate the SharpnessScore of an image. The SharpnessScore of the image, is returned in the SharpnessScore field of the Histogram window. The ROI defines the area, within the currently defined Region of Interest, that is use by the camera to compute the image SharnessScore. The SharpnessScore of an image, is a metric of how many ‘crisp’ edges there are in the image. Higher values indicate the presence of more edges. Comparing the SharpnessScore of an image of one target to an image of a different target, is meaningless, as there are no units associated with the SharpessScore. Rather it is intended that this score could be used to compare subsequent images of the same target, as focal adjustments are made to the stream of images (with perhaps Focus Control, if the camera/lens supports it). The user should continue to make focal adjustments until this value is maximized (for this given target).

Preview Overlay

Will enable or disable the preview of the sharpness score ROI onto the preview window.

Focus Control

Manually or Automatically control the focal level of the image.


Command Line Options

PixeLINK Capture OEM supports the following command line options:

  • /preview - starts the preview window automatically.

  • /help - Display the help screen.

  • /allowMultipleInstances - Allow more than one instance.

  • /allowMultipleConnections - Allow connections to more than one camera at a time.

  • /jumbo - Enable jumbo frames.

  • /monitorAccessOnly - Cameras will be read-only.


Troubleshooting

Advanced Mode Troubleshooting

If you're experiencing a problem with PixeLINK Capture OEM in Advanced mode, it may be the camera or the software. Try the following:

  1. Review the relevant sections of this section. Most of the time, the answer is right there. PixeLINK Capture OEM is a good place to start.

  2. If that fails, disconnect the camera, wait five seconds, then reconnect it and start the application again.

  3. Still having trouble? Go to our main Technical Support topic for further instructions.


PixeLINK Tools

Along with software applications like PixeLINK Capture OEM and our Application Programming Interface, PixeLINK provides several tools to make your life easier.

  • PixeLINK Camera IP Address Assignment Tool - This tool helps in the assignment of Internet Protocol (IP) addresses to PixeLINK IP cameras. It can be used independently of PixeLINK Capture OEM. It also has a command line interface.

  • Flat Field Calibration Wizard - Absolutely essential to high-quality image capture, the Flat Field Calibration Wizard allows you to calibrate the camera and correct for uneven illumination.

http://www.pixelink.com

© PixeLINK All rights reserved.


Flat Field Calibration Wizard

Background

Camera application-dependent factors such as Fixed-Pattern Noise (FPN), Photo Response Non-Uniformity (PRNU), Illumination and Optical non-uniformities will have a negative impact on the quality of images captured. The effects of these parameters can be minimized and often eliminated by performing a proper Flat-Field Calibration (FFC).

FFC data is stored in non-volatile memory inside the camera. All FFC-enabled PixeLINK cameras are shipped with factory calibrated FFC, done at a gain of 0dB and at an integration time of 40ms – 100ms depending on the camera model, without a lens under very uniform light using an integrating sphere. Since the camera will be operated in your application environment, which will have it’s own unique set of operating conditions (lighting, optics, gain, integration time), it is imperative that you perform the Flat-Field Calibration using your operating environment.

Illumination

Regardless of the type of light source used it is extremely difficult, if not impossible, to have a perfectly even illumination pattern on the object being imaged.

Without FFC – Non-uniform Light Source Following FFC

The above images were taken against a flat white board using a single light source positioned to the left of the camera. Notice the effect that the light source has before FFC was performed. After FFC has been completed, the same white board appears evenly illuminated using the same camera settings, camera lens and light source.

Fixed-Pattern Noise (FPN)

Fixed Pattern Noise (FPN) is a fixed pixel-to-pixel offset and is due to a combination of variations in image pixel geometry, substrate material and dark current. It is fixed with respect to illumination; however, it is temperature, integration time and gain dependent. FPN is measured under dark conditions at a given integration time, temperature and gain.

Dark current is linear with respect to integration time and doubles with every 6-8oC increase in temperature. As such, a camera which has been factory calibrated and is then used in a high-heat environment will exhibit much more dark current than when it was originally calibrated. Performing FFC in the operating environment will compensate for this.

Illustration of Fixed Pattern Noise in a 16 Pixel (4x4) Area Array (Magnified)

Photo Response Non-Uniformity (PRNU)

Theoretically, when a fixed, uniform light falls on the pixels of a CCD/CMOS sensor, each cell should output the exact same voltage. However, due to a variety of factors including slight variations in pixel geometry and substrate material, this is not the case. When a uniform light is transmitted onto the pixels of a CCD or CMOS camera, the pixels output slightly different voltages. This difference in response to a uniform light source is referred to as Photo Response Non-Uniformity or PRNU. Since PRNU is caused by the physical properties of a sensor, it is nearly impossible to eliminate and is therefore usually considered to be a normal characteristic of the sensor array used in any CCD or CMOS camera.

The following images show the effects of PRNU and how it becomes more pronounced with increased integration time and gain. The first image was taken using a 38ms integration time with 0dB gain. The second image was taken using a 240ms integration time with 18.1dB gain and the third image also uses a 240ms integration time with 18.1dB gain, but with a substantially improved image due to FFC. Histograms for each image are also provided.

38ms integration, 0dB gain before FFC

240ms integration, 18.1dB gain before FFC

240ms integration, 18.1dB gain after FFC

Optics

Several factors must be considered when determining the quality of a lens including sharpness, contrast, color correction, relative illumination, spectral transmission and distortion. These factors result in lenses producing slight variations between the object and the image.

Lens intensity varies from the center to the edge of the image with the center being brighter than the edges. This can often affect the suitability of a lens for your application and should be examined prior to integrating a lens into your application. This non-uniformity is caused by two factors: the first is the natural decrease in illumination from the center of the image circle to the edge of the lens and is known as the cosine fourth effect. The second, known as mechanical vignetting, is often present and results in some rays being blocked by mechanical parts located within the lens. Vignetting of this type can often be greatly reduced by using a smaller aperture.

Using the Histogram to Implement Even Illumination

The histogram feature provided in PixeLINK Capture OEM can be useful in configuring a light source to optimize the illumination pattern to be as uniform as possible. To access the histogram, click View | Histogram or press Ctrl+H while in PixeLINK Capture OEM. A uniform light source is represented graphically by a very narrow or “tight” histogram, whereas non-uniform lighting is shown as a broad or wide histogram. The following histograms and their respective images, illustrate uniform and non-uniform light. To use the histogram as an aid in configuring your light source, enable the histogram, adjust your camera settings and then adjust your light source until the histogram is as narrow as possible.

Uniform Light (Mono Camera) Non-Uniform Light (Mono Camera)

Uniform Light (Color Camera) Non-Uniform Light (Color Camera)

Uniform Light Image Sample Non-Uniform Light Image Sample

Before Performing Flat-Field Correction (FFC)

Ensure that you have a flat white or grey card that covers in the entire Field of View (FOV) of the camera before proceeding with the FFC Wizard. If the lens is focused perfectly, the camera will be able to image the surface irregularities (texture) of the card and the FFC will compensate or correct for the surface texture. Therefore it is important to defocus the lens when capturing the FFC bright field image (see step #7 below).

Performing FFC

For optimum image quality, the FFC wizard supplied by PixeLINK should be used to perform Flat Field Calibration for each camera in it’s specific application environment. Changes in lighting, optics or camera settings after the FFC has been performed may result in the camera not delivering optimum image quality. If any of these variables are altered, FFC should be performed again.

Note

Before performing FFC, the bright field image mean must be between 45% & 70% of Saturation level. If it falls outside of this range the FFC wizard will not work properly. Image Mean can be adjusted using the iris on the lens, however this is not always an acceptable or available method of adjusting this property. As such, we recommend that image mean be adjusted to an acceptable value using the camera settings (gain and/or integration time) prior to running the FFC wizard. 45% & 70% translate into 114.75DN & 178.5DN on the histogram respectively. The following images illustrate acceptable and unacceptable bright field image mean as well as how the information is shown on the histogram. The Mean value below the histogram is the value that we are concerned with and it should be between 115DN & 179 DN.

Acceptable Bright Field Image Mean & Unacceptable Bright Field Image Mean &

Corresponding Histogram Corresponding Histogram (Too Low)

FFC Wizard Steps

1. From within PixeLINK Capture OEM, set all camera settings to the values that are to be used in the application environment. These settings include, Exposure Time, Gain, Brightness and Pixel Format. Also, the Region of Interest should be set to the maximum camera resolution.

2. After the camera settings have been set, click Camera | Save Camera Settings and then save the configuration to Channel 1.

3. After the camera settings have been saved, exit PixeLINK Capture OEM and launch the FFC Calibration Tool by clicking Start | Programs | PixeLINK | Tools | FFC Wizard. When the FFC Calibration Tool opens, review the pre-calibration notes and click Next to continue

4. You will have the choice to either Calibrate FFC or Load FFC From File. The later is useful if you must revert back to a previously saved configuration for any reason. Click Calibrate FFC and click Next.

5. It is strongly advised that you save the existing FFC configuration prior to proceeding to the next step. In the event that the FFC generates undesired results or fails, you will then be able to restore the FFC calibration to its factory default state. If you do not want to save the existing configuration, enable the check box labeled Skip This Step and click Next.

6. The FFC Wizard is now ready to capture Dark Fields. Before clicking next to begin capturing Dark Fields, ensure that the lens has been capped with a lens cap that does not permit any light from entering the camera. If possible, turn off or block any light including ambient light sources as even the slightest amount of light can generate undesired results if allowed to enter the image sensor.

7. After Dark Field images have been captured, the FFC Wizard will be ready to capture Bright Fields. Remove the lens cap from the camera and ensure that the light source and optics used in your application have been set to the normal operating conditions. Click Next to continue.

8. In the even that the Image Mean is not between 45% and 70%, you will be prompted with an error similar to the following:

The image mean can be altered either by adjusting the lens iris so that it is more open or closed (depending on whether Image Mean is below 45% or above 70%) or by adjusting the camera settings. If you cannot adjust your iris to correct this, you must Abort the FFC Wizard and then adjust your camera settings using PixeLINK Capture OEM so that Image Mean falls between 45% & 70% saturation. You can determine when the Image Mean is acceptable by using the Histogram as illustrated at the beginning of the Performing FFC section.

9. After Bright Fields have been captured, the FFC Calibration will have to be saved to the camera. Click Next to begin writing the data to the camera.

10. When the data has been written, click Finish to exit the FFC Wizard.

11. Disconnect and reconnect your camera for the new FFC Calibration to take effect.

http://www.pixelink.com

© PixeLINK All rights reserved.


IP Address Assignment Tool

This document describes the PixeLINK Camera IP Address Assignment Tool (PxLIpAddress.exe) which is used with network based cameras to manage the IP address assignment. The document has the following sections:

  • What's New

  • PixeLINK Cameras and IP Addresses

  • Dialog Based Mode

  • Command Line Mode

  • IP Address Assignment FAQ

PixeLINK Cameras and IP addresses

Network based PixeLINK cameras (currently, only cameras with a Gigabit Ethernet interface) must have a valid IP address assigned to it in order to function correctly. This tool can be used to manage the IP address assignment for these cameras. More precisely, it allows you to manage the IP configuration of the Pleora Technologies IP Engines, which are located within the networked PixeLINK cameras. The program has two operational modes; dialog based interactive mode, and command line based mode. Both modes of operation will allow you to manage the IP Engine's IP address assignment using either dynamic (or automatic) IP address assignment, or static IP address assignment.

Static vs. Dyanmic IP Address Assignment

Dynamic IP Address Assignment, or what Microsoft Windows refers to as automatic, is the technique used by the camera by default. That is, the camera will query the network to which it is attached to try to assign itself an IP address appropriate for the network. Should your network have a DHCP (Dynamic Host Configuration Protocol) server, then the camera will receive IP configuration information from the server. In the absence of a DHCP server, the camera will use LLA (Link-Local Address) to assign itself an IP address. It’s noteworthy that the LLA process can take up to a minute to resolve an IP address, so DHCP is generally the preferred technique for dynamic IP address assignment. A camera which has used LLA to determine its network address, can be identified by having an address on the 169.254.0.0/16 IP subnet (having an IP address of 169.254.ddd.ddd and a subnet mask of 255.255.0.0).

Static IP Address Assignment requires the user to assign the IP configuration to the camera (using this tool). This technique requires more network knowledge, and is typically only used in point-to-point connections, or in very small networks.

If you are unclear on what IP address assignment technique to use, or what IP address to assign, looking at the "Internet Protocol (TCP/IP) Properties" page within Windows is a good place to start (found under Start->ControlPanel->Network Connections->Properties of your NIC->Internet Protocol (TCP/IP) Properties).

If your NIC is set to "Obtain an IP address automatically", then your camera should be usable without any further configuration, as it too will use Dynamic IP address assignment. However, if your NIC is set to "Use the following IP address" (as shown in the figure above), then you will have to use static IP address assignment for your camera. Choose an IP address which is not being used by any other device on the network. Choosing an IP address which is one greater than the NIC IP address, is often a good choice (EG. NIC IP Address: 192.168.1.10 --> IP Engine IP Address: 192.168.1.11). You should set the cameras subnet mask and default gateway to the same values used by the NIC (the defaults used by this program).

http://www.pixelink.com

© PixeLINK All rights reserved.


What's New

What's New with the IP Address Tool

Revision | Release Date | Notes
1.3.1 | May 2, 2008 | Re-designed the dialog based interactive mode. Added the capability to set and unset IP configuration persistence using interactive mode
1.2 | Feb 20, 2008 | Initial Release

http://www.pixelink.com

© PixeLINK All rights reserved.


IP Address Assignment Tool - Dialog Based Mode

You enter this mode simply by running the application without any command line parameters; this program will then scan your network for PixeLINK cameras. The program will then present a dialog showing IP configuration information on one of the cameras connected to your network. The dialog is as follows:

The Camera group of the dialog, shows information pertinent to a particular networked PixeLINK camera found on the network. You can use the MAC drop down list to select other networked PixeLINK cameras. The Network Interface Card group shows information pertinent to the NIC from which the selected camera is subtended. The following sections outline the meaning/use of each of the fields within the dialog.

Camera fields

Mac:

This is a drop down list showing the Media Access Control (MAC), or ‘network’, address assigned to the camera at time of manufacture. You can use this control to select a specific networked PixeLINK camera. Once selected, all of the other information in the Camera group, and to a lesser extent, the Network Interface Card group, is centric to this camera.

Selecting a camera using this dialog, may take a few seconds.

Serial Number:

The serial number of the selected camera. Note that this filed will appear blank if the tool cannot read the serial number of the camera. The most common reasons for this would be that the camera is not on the same subnet as the NIC, or the NIC is not using a supported driver type.

IP Engine Version:

This is the version of the Pleora Technologies IP Engine within the PixeLINK camera.

IP Configuration:

  • IP Address – The IP address being used by the camera.

  • IP Subnet Mask – The IP subnet Mask being used by the camera.

  • Default Gateway – The default gateway used by the camera.

  • Update Button – This control is enabled once you edit any of the IP configuration for the camera (any of the above 3 parameters). Pressing this button will ‘commit’ the IP configuration to the camera.

  • Persistent Checkbox – This control can only be activated if the selected camera supports persistent static IP address assignment. Pressing the Update button with Persistent checked, will not only commit the IP configuration to the camera, but the camera will continue to use this particular IP configuration across power cycles of the camera. Pressing the Update button with Persistent NOT checked, means that the camera will revert to dynamic IP address assignment on the next power cycle.

You should not check the Persistent box if you are using dynamic address assignment on your network.

Network Interface Card fields

All of the fields within this group pertain to the Network Interface Card (NIC) from which the selected camera (as identified by the MAC field of the Camera group) is subtended.

Mac:

This the MAC address assigned to the NIC at time of manufacture.

Driver:

This filed identifies the Pleora Technologies driver used by the NIC, to communicate with the camera. The driver is installed using Pleora’s Driver Installation Tool. If the driver being used by the NIC is not supported by the camera, an error message will be displayed.

IP Configuration:

  • IP Address – The IP address being used by the NIC.

  • IP Subnet Mask – The IP subnet Mask being used by the NIC.

  • Default Gateway – The default gateway used by the NIC.

Other fields

Messages and Clear Button:

This is a scrollable window used for error, warning, and informative messages. The Clear Button can be used to clear all of the messages currently in this window.

Number Of Cameras Found:

This filed reports on the number of cameras found with the last network scan. The tool will scan the network for cameras, every 10 seconds or so.

IP Engine Explorer Button:

This button will launch the Pleora’s IP engine Selection dialog, which will show all of the IP Engines found on the network. Note that this tool will not only find networked PixeLINK cameras, but other devices which contain an IP engine from Pleora Technologies.

It is included within this tool, for diagnostic purposes.

Help Button:

Displays this help dialog.


IP Address Assignment Tool - Command Line Mode

This program supports the following command line parameters:

  • /ip ddd.ddd.ddd.ddd - Used to specify the IP address of a connected IP Engine (static assignment). The camera will use the same IP subnet mask as the NIC from which it is subtended.

  • /p_ip ddd.ddd.ddd.ddd - Same as /ip option, but the IP address is committed to non-volatile memory, so the address will persist across camera power cycles. Specify an address of 0.0.0.0 to have the camera 'forget' this assigned IP address, and to resort back to using dynamic (DHCP or LLA) IP address assignment.

  • /mac XX-XX-XX-XX-XX-XX - The MAC address of the camera for which the IP address is to be applied. This parameter is only necessary if there is more than one camera on the subnet matching the supplied IP address.

  • /help or /? - Display a command line help screen

Note

The /ip and /p_ip parameters are mutually exclusive; they cannot be used together.

Examples:

PxLIpAddresses /ip 192.168.1.11 - Sets the IP address of the connected camera to 192.168.1.11.

PxLIpAddresses /mac 00-11-1C-F3-00-0A /p_ip 192.168.1.11. - Sets the IP address of the camera identified my MAC address 00-11-1C-F3-00-0A, to 192.168.1.11. What's more, the camera will maintain this address across power cycles.

PxLIpAddresses /p_ip 0.0.0.0 - The connected camera will no longer use a persistent IP address. The next time the camera is power cycled; it will revert to using DHCP or LLA to determine its IP address.

http://www.pixelink.com

© PixeLINK All rights reserved.


IP Address Assignment Tool FAQ

Q/ PxLIpAddresses tool finds my camera just fine, but neither my application nor Capture OEM, finds the camera.

A/ The two most common reasons why this may occur are:

  • The NIC from which the camera is subtended, is not using a driver type supported by the camera. If this is the case, a warning message would appear in the Messages window. Under these circumstances, you must use Pleora’s Driver installation Tool to install a new driver for the NIC.

  • The Camera and the NIC are not on the same IP network. If this is the case, a warning message to this affect will be displayed in the Messages window. To correct this error, you can either use this tool to change the IP configuration of the camera, or use the Windows Network Properties dialog to change the IP configuration of the NIC, or both.

Q/ How do I assign a static IP address to the camera such that the camera will continue to use this address in spite of power cycles?

A/ Set the Cameras IP Configuration as appropriate, check the Persistent box, then press the Update button.

Q/ I was using static IP address assignment on this camera, but I now want to use dynamic IP address assignment. How do I do this?

A/ Edit any one of the Camera IP Configuration parameters to enable the Update button. Ensure the Persistent check box is clear, then press the Update button. The camera will acquire/use a dynamic IP address with the next (and subsequent) power cycles.

Q/ I cannot get the Camera Persistent control to enable – it continually remains grayed out. What could cause this?

A/ This control will remain grayed out if the selected camera does not support persistent static IP address assignment.

http://www.pixelink.com

© PixeLINK All rights reserved.


ApiSpy

The ApiSpy is a utility you can use to examine an application's interactions with the PixeLINK Api. It is a DLL that looks to Windows -- for all intents and purposes -- exactly like the real PixeLINK API DLL (viz. PxLApi40.dll), and therefore, if the ApiSpy is in the search path before the *real* PixeLINK API, it will be loaded and used by Windows.

When loaded into an application, the ApiSpy loads the real PixeLINK API DLL, and then when PixeLINK API functions are called, the ApiSpy passes them along to the PixeLINK API DLL, and returns the results to the application.

By sitting between the application and the PixeLINK API DLL, the ApiSpy can log and provide a peek into all activity between an application and the cameras with which it's interacting.

Two versions of the ApiSpy are provided:

Name | Description
PxLApi40.ApiSpy.x86.dll | 32-bit version, for use with 32-bit applications.
PxLApi40.ApiSpy.x64.dll | 64-bit version, for use with 64-bit applications.

To install the ApiSpy:

Ensure the application is not running.

Copy the appropriate ApiSpy (32-bit/64-bit) the same directory (folder) as the application you want to spy on.

Rename the dll to be PxLApi40.dll.

Run the application.

To view the information logged by the ApiSpy log, use Microsoft's DebugView application, available for free here.

If you are running the application under a debugger, the output will appear in the 'Output' window.

The tool, ApiSpyConfig, can be used to filter the functions and features to log.

http://www.pixelink.com

© PixeLINK All rights reserved.


Static Defective Pixel Correction

Static Defective Pixel Correction Wizard Guide

Note

This tool is designed to be used on PL-C and PL-D PixeLINK camera models only. For older PL-A and PL-B PixeLINK cameras, please use the FFC Wizard tool.

Camera sensors almost always have some pixels that don’t have the full dynamic range that they should. These dead, hot (too bright) and cold(too dark)pixels can be corrected for with the Static Defective Pixel Correction(SDPC) routine. This routine corrects the defective pixel with interpolated values based on neighboring pixels.

Typical correction methods include averaging with immediate same-color neighbors, or even going out to the second set of neighbors. Correction can span multiple pixels if by some chance many consecutive pixels in a row are defective. Boundary conditions also exist to handle defective pixels at the edges of the image array.

This type of calibration is already done at the factory but you may wish to re-calibrate your camera in the field if you are noticing bad pixels with your specific camera settings. The PixeLINK SDK and camera kit come with the SDPC Wizard application to help you accomplish this.

When to Use

Use the SDPC Wizard when:

  • Your exposure rate is very long. Larger exposure times cause a wider variance in charge accumulation per pixel and thus pixel intensity. This can lead to more noticeable differences in pixel intensity.

  • You are using a high gain. Increased gain can have a similar effect to large exposure times. It amplifies differences in pixel intensity as well as noise.

  • Your operating environment is of a different temperate room temperature. Pixel noise and responsively can change with temperature. For reference - factory calibration is performed ata camera temperature of 40C.

  • You wish to save your factory default or current SDPC values to file

  • You wish to restore a previously saved set of SDPC values or use custom user values.

How to Use

The procedure is best done in your operating environment after the camera has been running for a period of time. If this is not possible, simulate as close as possible with regards to camera settings, running camera temperature and lighting.

It is recommended you remove the lens from your camera before using the SDPC Wizard. Otherwise, optical effects can cause pixels to be incorrectly flagged as defective.

Once your camera is connected and set to the desired configuration, launch the SDPC Wizard:

  • Start Menu -> PixeLINK-> Tools -> SDPC Wizard

After clicking next on the opening dialog, your camera will be detected and you will be brought to the SDPC Configuration page. Check the model and serial number to be sure you are connected to the desired camera.

From this page you can load factory default gain/exposure, load previously saved settings from memory channel 1, or change the exposure/gain manually. Video preview is available for all of these options to check your target image and can be left running during calibration if desired. This will allow you to see the before and after effects of the calibration. The SDPC Preview check box will allow you to manually do this.

By default, the software will save a backup of the calibration data, the new calibration data and a log file to your “Documents” folder. You may disable any of these options or change the save path if desired. You may also load SDPC calibration data from a data file instead of re-calibrating manually.

Clicking “Start SDPC Calibration” will start the calibration progress. A dialog will launch asking you to provide a dark scene to analyze. It is recommended you use the sensor cover that came with your camera to provide the dark scene for calibration. Once this is complete, the software will average a series of frames, looking for pixels behaving poorly and flag any found. The main failures looked for are hot pixels which have a significantly higher value compared to the rest of the scene and noisy pixels which have too much fluctuation in value from frame to frame.

If you enabled Bright Frames SDPC testing from the configuration page then after dark frame analysis is complete you will be asked to provide a uniform bright scene for similar type of bright frame analysis. It may not be possible in all configurations and environments to provide the required bright target scene. In that case, the dialog can be cancelled and calibration will be done using only the dark scene data. The vast majority of marginal pixels are captured in the dark scene analysis. Skipping bright scene calibration should not a major concern for most users.

The final list of marginal pixels is analyzed based on failure mode and weighted to produce a list of defective pixels. If more pixels are found than can be automatically corrected for in hardware, the worst offenders are flagged as defective. All of the analysis data will be saved to file. The output file will flag each type of pixel failure as follows:

Pixel_Good, // This pixel is not known to be defective (default)

Pixel_Blinker_Dark, // Too much temporal variation in low light

Pixel_Cold_Dark, // Low under low light

Pixel_Hot_Dark, // High under low light

Pixel_Blinker_Bright,// Too much temporal variation in higher lighting conditions

Pixel_Cold_Bright, // Low in higher lighting conditions

Pixel_Hot_Bright, // High in higher lighting conditions

Pixel_Bad_User, // User flagged defective pixel

This data can be used by the user for manual editing or post capture image processing if desired.

http://www.pixelink.com

© PixeLINK All rights reserved.


Camera Update Wizard

Note

This tool is designed to be used on PL-C and PL-D PixeLINK camera models only. For older PL-A and PL-B PixeLINK cameras please use our FFC Wizard tool or contact PixeLINK Support.

This tool will guide you through the process of updating the firmware and FPGA in your PixeLINK camera

  • Ensure that only one camera is connected

  • An Internet connection is required for the "Check For New Firmware" Feature

  • You can also specify a local directory with the camera files to update the camera

http://www.pixelink.com

© PixeLINK All rights reserved.


Technical Support

For FAQ's/troubleshooting tips and other useful information please visit our online Knowledge base: http://www.pixelink.com/support/knowledge-base/pixelink-knowledge-base.aspx

PixeLINK Customer Support

Contact: http://www.pixelink.com/corporate/contact-us.aspx

Web: http://www.pixelink.com/

http://www.pixelink.com

© PixeLINK. All rights reserved.


Feedback

We Need Your Feedback

Do you have a recommendation for improvements that we can incorporate into our documentation?

We want to hear from you... Let us know if you have a suggested topic that isn't currently covered, or if you find that there isn't enough detail on materials that are already included.

We are continuously looking for ways to enhance our documentation, so...

Send an email to support@pixelink.com. Let us know what you are looking for, or how we could improve on the current presentation.


Copyrights and Trademarks

Copyright Notice and Trademarks

Copyright © 1999-2009, PixeLINK. All rights reserved.

This help file contains proprietary and confidential information of PixeLINK. The contents of this help file may not be copied nor duplicated in any form, in whole or in part, without prior written consent from PixeLINK.

By using this help file, the user agree(s) to abide by the terms of this Agreement and read and recognize the following set of definitions appertaining to the intellectual-property items and trademark references as can be found throughout this help file.

Change Disclaimer

PixeLINK provides the information and data included in this help file for the user's benefit, but it is not possible for PixeLINK to entirely verify and test all of this information in all circumstances, particularly information relating to non-PixeLINK manufactured products. PixeLINK makes no warranties or representations relating to the quality, content, or adequacy of this information. Every effort has been made to ensure the accuracy of this Guide; however, PixeLINK assumes no responsibility for any errors or omissions in this help file. PixeLINK shall not be held liable for any errors or for incidental or consequential damages in connection with the furnishing, performance, or use of this help file or the examples herein.

PixeLINK assumes no responsibility for any damage or loss resulting from the use of this help file, loss or claims by third parties which may arise through the use of this product, any damage or loss caused by deletion of data as a result of malfunction or repair, or any other damage related to the use of this product or associated documentation. The information in this help file is subject to change without notice.

Definitions of Intellectual Property and Trademark Attributions

This Section is intended to ensure proper attribution and honoring of any and all trademarks and intellectual-property items in terms of attribution to their respective owners as mentioned in this help file. The reader is encouraged to consult this Section whenever uncertainty presents itself as to the terms, their meaning within the help file, and the trademarks and intellectual-property items they stand to identify, whether by themselves or in conjunction with other terms and items.

PixeLINK is either a trademark or a registered trademark of PixeLINK in Canada and/or other countries; IEEE is a registered trademark or service mark of the Institute of Electrical and Electronics Engineers, Incorporated in the United States and/or other countries; FireWire is a trademark of Apple Computer, Inc., registered in the U.S. and other countries; Microsoft, DirectShow, and Windows are either trademarks or registered trademarks of Microsoft Corporation in the United States and/or other countries; TIFF is a trademark or registered trademark of Adobe Systems Incorporated in the United States and/or other countries. All other products, brand names, company names are trademarks or registered trademarks of their respective owners.

Mar-2009

http://www.pixelink.com

© PixeLINK. All rights reserved.


Actual Frame Rate

Supported by ...

All USB3 PixeLINK cameras.

Description

This read-only feature allows the user to query the camera to see what frame rate the camera will use while streaming image data. This value is generally be the same as FEATURE_FRAME_RATE, but will be a lesser value if the user is controlling the frame rate (IE, FEATURE_FRAME_RATE is enabled) and one of the following conditions is true:

  • The current camera exposure is preventing the camera from achieving the frame rate requested by FEATURE_FRAME_RATE or

  • FEATURE_BANDWIDTH_LIMIT is enabled, and its current value is preventing the camera from achieving the frame rate requested by FEATURE_FRAME_RATE.

API Control

PxLGetFeature

Feature | Number of Parms | Parameters | Units | Restrictions
FEATURE_ACTUAL_FRAME_RATE | 1 | fValue | frames per second | N/A

Feature Flags

Camera | Presence | Read Only | Auto | Manual | One-time Auto | Off | Settable while streaming | Persistable
All USB3 cameras | Yes | Yes | No | No | No | No | N/A | No

Parameters

Camera | Parameter | Unit | Type | Min | Max | Default | Step Size | Comments
All USB3 Cameras | Actual frame rate | Millions of bits per second | Absolute | 0 | Will never be greater than FEATURE_FRAME_RATE | Same value as FEATURE_FRAME_RATE | Same value as FEATURE_FRAME_RATE |


FAQs

Browse to the section that interests you and read the most commonly asked questions about that topic.

  • Installation FAQ

  • Camera FAQ

  • PixeLINK Capture OEM FAQ

  • API FAQ

  • LabVIEW FAQ

  • IIDC Protocol FAQ


Capture OEM FAQ

PixeLINK Capture OEM can actively control one camera at a time, while running preview windows for other cameras (up to the capacity of the FireWire bus).

Multiple cameras can be controlled simultaneously by other methods, such as using custom applications created with the PixeLINK Camera API (included in the PixeLINK Megapixel FireWire Camera Developer’s Kits).

If several versions of PixeLINK Capture OEM are open in a single session, the values saved for the next session are those from the last window to be closed in the current session.

Yes, the Preview Window can be started automatically by using the command line switch "/preview".

PixeLINK Help - PixeLINK Capture OEM Help

PixeLINK Capture OEM FAQ

Q. Can PixeLINK Capture OEM handle more than one camera?

Q. Can the Preview Window be started automatically?


API Call Log

PixeLINK Capture OEM demonstrates the capabilities of PixeLINK cameras and the PixeLINK Camera API. At the bottom of each Tab in Advanced Mode, the PixeLINK API commands are logged as they are called by the application.

This feature provides information about the sequence in which calls are made and is designed to assist application developers when integrating the camera and creating custom programs with the API.

Filter Dialog

  • Select desired API function calls to appear in the log window

  • Select Get/Set Camera Feature calls to be displayed

  • Clear All to eliminate all log output